"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MangoV3ReimbursementClient = exports.ID = void 0;
var anchor_1 = require("@project-serum/anchor");
var web3_js_1 = require("@solana/web3.js");
var mango_v3_reimbursement_1 = require("./mango_v3_reimbursement");
exports.ID = new web3_js_1.PublicKey("m3roABq4Ta3sGyFRLdY4LH1KN16zBtg586gJ3UxoBzb");
var MangoV3ReimbursementClient = /** @class */ (function () {
    function MangoV3ReimbursementClient(provider) {
        this.program = new anchor_1.Program(mango_v3_reimbursement_1.IDL, exports.ID, provider);
    }
    MangoV3ReimbursementClient.prototype.decodeTable = function (group) {
        return __awaiter(this, void 0, void 0, function () {
            var ai, rowSize, tableHeaderSize, rows;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.program.provider.connection.getAccountInfo(group.table)];
                    case 1:
                        ai = _a.sent();
                        if (!ai) {
                            throw new Error("Table ai cannot be undefined!");
                        }
                        rowSize = this.program._coder.types.typeLayouts.get("Row").span;
                        tableHeaderSize = 40;
                        rows = (ai.data.length - tableHeaderSize) / rowSize;
                        return [2 /*return*/, __spreadArray([], __read(Array(rows).keys()), false).map(function (i) {
                                var start = tableHeaderSize + i * rowSize;
                                var end = start + rowSize;
                                return _this.program._coder.types.typeLayouts
                                    .get("Row")
                                    .decode(ai.data.subarray(start, end));
                            })];
                }
            });
        });
    };
    MangoV3ReimbursementClient.prototype.reimbursed = function (reimbursementAccount, tokenIndex) {
        return (reimbursementAccount.reimbursed & (1 << tokenIndex)) !== 0;
    };
    MangoV3ReimbursementClient.prototype.calimTransferred = function (reimbursementAccount, tokenIndex) {
        return (reimbursementAccount.calimTransferred & (1 << tokenIndex)) !== 0;
    };
    return MangoV3ReimbursementClient;
}());
exports.MangoV3ReimbursementClient = MangoV3ReimbursementClient;
