"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAssociatedTokenAccountIdempotentInstruction = void 0;
var mango_client_1 = require("@blockworks-foundation/mango-client");
var anchor_1 = require("@project-serum/anchor");
var web3_js_1 = require("@solana/web3.js");
var spl_token_1 = require("@solana/spl-token");
var client_1 = require("./client");
var bn_js_1 = __importDefault(require("bn.js"));
var fs_1 = __importDefault(require("fs"));
/// Env
var CLUSTER_URL = process.env.CLUSTER_URL_OVERRIDE || process.env.MB_CLUSTER_URL;
var PAYER_KEYPAIR = process.env.PAYER_KEYPAIR_OVERRIDE || process.env.MB_PAYER_KEYPAIR;
var GROUP_NUM = Number(process.env.GROUP_NUM || 5);
var CLUSTER = process.env.CLUSTER_OVERRIDE || "mainnet-beta";
var MANGO_V3_CLUSTER = process.env.MANGO_V3_CLUSTER_OVERRIDE || "mainnet";
var MANGO_V3_GROUP_NAME = process.env.MANGO_V3_GROUP_NAME_OVERRIDE || "mainnet.1";
var options = anchor_1.AnchorProvider.defaultOptions();
var connection = new web3_js_1.Connection(CLUSTER_URL, options);
// Mango v3 client setup
var config = mango_client_1.Config.ids();
var groupIds = config.getGroup(MANGO_V3_CLUSTER, MANGO_V3_GROUP_NAME);
if (!groupIds) {
    throw new Error("Group ".concat(MANGO_V3_GROUP_NAME, " not found"));
}
var mangoProgramId = groupIds.mangoProgramId;
var mangoGroupKey = groupIds.publicKey;
var mangoV3Client = new mango_client_1.MangoClient(connection, mangoProgramId);
Error.stackTraceLimit = 1000;
function createAssociatedTokenAccountIdempotentInstruction(payer, owner, mint, ata) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new web3_js_1.TransactionInstruction({
                    keys: [
                        { pubkey: payer, isSigner: true, isWritable: true },
                        { pubkey: ata, isSigner: false, isWritable: true },
                        { pubkey: owner, isSigner: false, isWritable: false },
                        { pubkey: mint, isSigner: false, isWritable: false },
                        {
                            pubkey: web3_js_1.SystemProgram.programId,
                            isSigner: false,
                            isWritable: false,
                        },
                        { pubkey: spl_token_1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
                    ],
                    programId: spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID,
                    data: Buffer.from([0x1]),
                })];
        });
    });
}
exports.createAssociatedTokenAccountIdempotentInstruction = createAssociatedTokenAccountIdempotentInstruction;
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var sig, admin, adminWallet, provider, mangoV3ReimbursementClient, sig_1, group, _a, _b, _c, index, tokenInfo, bU64, claimMint, claimTransferTokenAccount, sig_2, _d, _e, e_1_1, reimbursementAccount, rows, ra, _f, _g, _i, i, _h, _j;
        var e_1, _k, _l, _m;
        return __generator(this, function (_o) {
            switch (_o.label) {
                case 0:
                    admin = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(fs_1.default.readFileSync(PAYER_KEYPAIR, "utf-8"))));
                    adminWallet = new anchor_1.Wallet(admin);
                    provider = new anchor_1.AnchorProvider(connection, adminWallet, options);
                    mangoV3ReimbursementClient = new client_1.MangoV3ReimbursementClient(provider);
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 1:
                    if (!!(_o.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; })) return [3 /*break*/, 3];
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.methods
                            .createGroup(GROUP_NUM, new web3_js_1.PublicKey("mdcXrm2NkzXYvHNcKXzCLXT58R4UN8Rzd1uzD4h8338"), 1)
                            .accounts({
                            table: new web3_js_1.PublicKey("tab5DYiG5GXtdKjBSKFjY2RJc4zzo3WnWPDYM2FfeUd"),
                            payer: mangoV3ReimbursementClient.program.provider
                                .wallet.publicKey,
                            authority: mangoV3ReimbursementClient.program.provider.wallet.publicKey,
                        })
                            .rpc({ skipPreflight: true })];
                case 2:
                    sig_1 = _o.sent();
                    console.log("created group, sig https://explorer.solana.com/tx/".concat(sig_1 + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _o.label = 3;
                case 3: return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 4:
                    group = (_o.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; });
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 5:
                    // // Edit group, set new table
                    // await mangoV3ReimbursementClient.program.methods
                    //   .editGroup(new PublicKey("tab5DYiG5GXtdKjBSKFjY2RJc4zzo3WnWPDYM2FfeUd"))
                    //   .accounts({
                    //     group: group?.publicKey,
                    //     authority: (mangoV3ReimbursementClient.program.provider as AnchorProvider)
                    //       .wallet.publicKey,
                    //   })
                    //   .rpc();
                    // Reload group
                    group = (_o.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; });
                    _o.label = 6;
                case 6:
                    _o.trys.push([6, 15, 16, 17]);
                    return [4 /*yield*/, mangoV3Client.getMangoGroup(mangoGroupKey)];
                case 7:
                    _a = __values.apply(void 0, [(_o.sent()).tokens.entries()]), _b = _a.next();
                    _o.label = 8;
                case 8:
                    if (!!_b.done) return [3 /*break*/, 14];
                    _c = __read(_b.value, 2), index = _c[0], tokenInfo = _c[1];
                    // If token for index is set in v3
                    if (tokenInfo.mint.equals(web3_js_1.PublicKey.default)) {
                        return [3 /*break*/, 13];
                    }
                    // If token is still active in v3
                    if (tokenInfo.oracleInactive === true) {
                        return [3 /*break*/, 13];
                    }
                    // If vault has not already been created
                    if (!(group === null || group === void 0 ? void 0 : group.account.vaults[index].equals(web3_js_1.PublicKey.default))) {
                        return [3 /*break*/, 13];
                    }
                    bU64 = Buffer.alloc(8);
                    bU64.writeBigUInt64LE(BigInt(index));
                    return [4 /*yield*/, web3_js_1.PublicKey.findProgramAddress([Buffer.from("Mint"), group === null || group === void 0 ? void 0 : group.publicKey.toBuffer(), bU64], mangoV3ReimbursementClient.program.programId)];
                case 9:
                    claimMint = (_o.sent())[0];
                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(claimMint, group.account.claimTransferDestination)];
                case 10:
                    claimTransferTokenAccount = _o.sent();
                    _e = (_d = mangoV3ReimbursementClient.program.methods
                        .createVault(new bn_js_1.default(index)))
                        .accounts;
                    _l = {};
                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(tokenInfo.mint, group.publicKey, true)];
                case 11: return [4 /*yield*/, _e.apply(_d, [(_l.vault = _o.sent(),
                            _l.group = group.publicKey,
                            _l.mint = tokenInfo.mint,
                            _l.claimTransferTokenAccount = claimTransferTokenAccount,
                            _l.claimTransferDestination = group.account.claimTransferDestination,
                            _l.payer = mangoV3ReimbursementClient.program.provider
                                .wallet.publicKey,
                            _l)])
                        .rpc()];
                case 12:
                    sig_2 = _o.sent();
                    console.log("setup vault, sig https://explorer.solana.com/tx/".concat(sig_2 + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _o.label = 13;
                case 13:
                    _b = _a.next();
                    return [3 /*break*/, 8];
                case 14: return [3 /*break*/, 17];
                case 15:
                    e_1_1 = _o.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 17];
                case 16:
                    try {
                        if (_b && !_b.done && (_k = _a.return)) _k.call(_a);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 17: return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 18:
                    // Reload group
                    group = (_o.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; });
                    if (!((group === null || group === void 0 ? void 0 : group.account.reimbursementStarted) === 0)) return [3 /*break*/, 20];
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.methods
                            .startReimbursement()
                            .accounts({
                            group: group.publicKey,
                            authority: mangoV3ReimbursementClient.program.provider.wallet.publicKey,
                        })
                            .rpc()];
                case 19:
                    sig = _o.sent();
                    console.log("start reimbursement, sig https://explorer.solana.com/tx/".concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _o.label = 20;
                case 20: return [4 /*yield*/, web3_js_1.PublicKey.findProgramAddress([
                        Buffer.from("ReimbursementAccount"),
                        group === null || group === void 0 ? void 0 : group.publicKey.toBuffer(),
                        admin.publicKey.toBuffer(),
                    ], mangoV3ReimbursementClient.program.programId)];
                case 21:
                    reimbursementAccount = (_o.sent())[0];
                    return [4 /*yield*/, connection.getAccountInfo(reimbursementAccount)];
                case 22:
                    if (!!(_o.sent())) return [3 /*break*/, 24];
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.methods
                            .createReimbursementAccount()
                            .accounts({
                            group: group.publicKey,
                            mangoAccountOwner: admin.publicKey,
                            payer: mangoV3ReimbursementClient.program.provider
                                .wallet.publicKey,
                        })
                            .rpc({ skipPreflight: true })];
                case 23:
                    sig = _o.sent();
                    console.log("created reimbursement account for ".concat(admin.publicKey, ", sig https://explorer.solana.com/tx/").concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _o.label = 24;
                case 24: return [4 /*yield*/, mangoV3ReimbursementClient.decodeTable(group === null || group === void 0 ? void 0 : group.account)];
                case 25:
                    rows = _o.sent();
                    rows.find(function (row) { return row.owner.equals(admin.publicKey); }).balances;
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.reimbursementAccount.fetch(reimbursementAccount)];
                case 26:
                    ra = _o.sent();
                    mangoV3ReimbursementClient.reimbursed(ra, 0);
                    _f = [];
                    for (_g in [0, 2, 4])
                        _f.push(_g);
                    _i = 0;
                    _o.label = 27;
                case 27:
                    if (!(_i < _f.length)) return [3 /*break*/, 32];
                    i = _f[_i];
                    _j = (_h = mangoV3ReimbursementClient.program.methods
                        .reimburse(new bn_js_1.default(0), new bn_js_1.default(0), true))
                        .accounts;
                    _m = {
                        group: group.publicKey,
                        vault: group === null || group === void 0 ? void 0 : group.account.vaults[i]
                    };
                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(group === null || group === void 0 ? void 0 : group.account.mints[i], admin.publicKey)];
                case 28:
                    _m.tokenAccount = _o.sent(),
                        _m.reimbursementAccount = reimbursementAccount,
                        _m.claimMint = group === null || group === void 0 ? void 0 : group.account.claimMints[i];
                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(group === null || group === void 0 ? void 0 : group.account.claimMints[i], group === null || group === void 0 ? void 0 : group.account.claimTransferDestination)];
                case 29: return [4 /*yield*/, _j.apply(_h, [(_m.claimMintTokenAccount = _o.sent(),
                            _m.mangoAccountOwner = admin.publicKey,
                            _m.table = group === null || group === void 0 ? void 0 : group.account.table,
                            _m)])
                        .rpc({ skipPreflight: true })];
                case 30:
                    sig = _o.sent();
                    console.log("reimbursing ".concat(admin.publicKey, ", sig https://explorer.solana.com/tx/").concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _o.label = 31;
                case 31:
                    _i++;
                    return [3 /*break*/, 27];
                case 32: return [2 /*return*/];
            }
        });
    });
}
main();
